/**
 * @file	stack.c
 * @author	myusgun <myusgun@gmail.com>
 */
#include "cf_stack.h"
#include "cf_debug.h"

int main (void)
{
	long long int	iter = 0;
	int				result = 0;
	int				element = 0;
	CF_Stack_Ctx	ctx = NULL;

	// create
	result = CF_Stack_CreateCtx (&ctx);
	if (result < 0)
		CF_DEBUG_PRINT (stderr, "error %d\n", result);

	// insert
	for (iter = 0 ; iter < 10 ; iter++)
	{
		result = CF_Stack_Push (ctx, (void *)iter);
		if (result < 0)
			CF_DEBUG_PRINT (stderr, "error %d\n", result);
	}

	// move next
	for (iter = 0 ; iter < 10 ; iter++)
	{
		result = CF_Stack_Top (ctx, (void **)&element);
		if (result < 0)
			CF_DEBUG_PRINT (stderr, "error %d\n", result);
		else
			CF_DEBUG_PRINT (stderr, "top   : %4d\n", element);

		result = CF_Stack_Pop (ctx, (void **)&element);
		if (result < 0)
			CF_DEBUG_PRINT (stderr, "error %d\n", result);
		else
			CF_DEBUG_PRINT (stderr, "poped : %4d\n", element);

		CF_DEBUG_PRINT (stderr, "\n");
	}

	// destroy
	result = CF_Stack_DestroyCtx (ctx);
	if (result < 0)
		CF_DEBUG_PRINT (stderr, "error %d\n", result);

	return 0;
}
